﻿--[[
	Persistent Data for TellTrack, Saved Variables
]]

TellTrack = LibKarma:GetInstance( "TellTrack", {

} );

TellTrack:RegisterDB( "TellTrackDB", {
	Options = {
		Enabled = 1,
		InvertedList = 0,
		DontSaveList = 0,
		AutoCreate = 1,
		HideOtherWhispers = 0,
		TimeStamps = 0,
		WhisperFirst = 0,
		HideBorder = 0,
		DebugMode = 1,
		-- Internal flags
		Color = "|c0076dfff",			-- optional text accent color
		Realm = nil,					-- current realm
		Player = nil,					-- current logged in player name
		VersionCopy = 0,                -- [0|1]  Is imported CT_RaidTracker, one time thing very first load only
		VersionFix = 1,					-- [0...]  Current database version level
	},
	Log = { },
	Chat = { },
} );


function TellTrack:RunVersionFix( frame )
	local db = self._db;
	local log = db.Log;
	local o = self._options;
	o.VersionFix = o.VersionFix			-- copy and force default value to get saved

	if o.VersionCopy == 0 then
		if TellTrack_SavedList then
			self:Print("Importing TellTrack database.")
			self:ImportToDB( o, _G, "TellTrack_", false, true, { "Enabled", "HideBorder", "InvertedList", "DontSaveList",
				"AutoWhisperFrame", "HideOtherWhispers", "TimeStamps", "WhisperFirst", } );
			self:ImportToDB( nil, _G, "TellTrack_", false, true, { Chat="WhisperChatFrame", Log="SavedList",} );
		end
		o.VersionCopy = 1;
	end	
	
	if o.VersionFix == 0 then
		self:Debug("VersionFix", 1);
		self:ImportRenameDB( o, { "AutoCreate","AutoWhisperFrame", } );
		for k,v in pairs(db.Chat) do
			for k1,v1 in pairs(v) do
				if type(v1) ~= "table" then
					v[k1] = { name=nil, frame=v1 }
				end
			end
		end
		o.VersionFix = 1;
	end

end
